/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "Cierre.h"

Gda_Recordset *GetListadoTotalDeCierres (void)
{
  Gda_Recordset *grs;
  gint rc;
                                        
	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
				"SELECT CD_CIERRE, FE_CIERRE, COMPROBANTE, TIPO FROM CIERRE ORDER BY FE_CIERRE",
                              	GDA_OPEN_STATIC,
                              	GDA_LOCK_PESSIMISTIC,
                              	0);
  	if (rc < 0) {
    		g_print(stderr, "\nNo se pudo ejecutar la consulta\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

Gda_Recordset *GetListadoFechasCierres (void)
{
  Gda_Recordset *grs;
  gint rc;
                                        
  	grs = gda_recordset_new();
  	gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
  	rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
				"SELECT FE_CIERRE FROM CIERRE ORDER BY FE_CIERRE",
                              	GDA_OPEN_STATIC,
                              	GDA_LOCK_PESSIMISTIC,
                              	0);
  	if (rc < 0) {
    		g_print(stderr, "\nNo se pudo ejecutar la consulta\n");
    		gtk_main_quit();
  	}

  	return GDA_RECORDSET(grs); 
}

gint InsertNuevoCierre (gchar *Fecha, gchar *Comprobante, gchar *Tipo)
{
   gchar *ConsultaInicial = "INSERT INTO CIERRE(FE_CIERRE,COMPROBANTE,TIPO) VALUES('";
   gchar *ConsultaTmp = NULL;
   Gda_Recordset *grs;
   Gda_Command* cmd;
   gulong* n=0;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,Fecha,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,Comprobante,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"','",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,Tipo,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"')",NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);

        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);

	return 0;
}

gint DeleteCierre (gchar *CodigoCierre)
{
   gulong* n=0;
   gchar *ConsultaInicial = "DELETE FROM CIERRE WHERE CD_CIERRE=";
   gchar *ConsultaTmp = NULL;
   Gda_Recordset *grs;
   Gda_Command* cmd;
 
        ConsultaTmp = g_strconcat(ConsultaInicial,CodigoCierre,NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
 
        cmd = gda_command_new();
        gda_command_set_connection (cmd,cnc);
        gda_command_set_text(cmd,ConsultaTmp);
   
        gda_connection_begin_transaction (cnc);
        grs = gda_command_execute(cmd,&n,0);
        gda_connection_commit_transaction (cnc);
   
	return 0;

}

gchar *ConsultarCodigoCierre(gchar *Fecha, gchar *Comprobante, gchar *Tipo)
{                                                 
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT CD_CIERRE FROM CIERRE WHERE FE_CIERRE='";
   gchar *ConsultaTmp = NULL;
   gchar *CodigoCierre = NULL;
   Gda_Field *field;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,Fecha,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"' AND COMPROBANTE='",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,Comprobante,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"' AND TIPO='",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,Tipo,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();      
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
                                                  
        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);
   
        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
   
        CodigoCierre = (gchar *)gda_stringify_value(CodigoCierre, 0, field);
   
        return CodigoCierre;        
}

gchar *ConsultarCodigoCierreFecha(gchar *Fecha)
{                                                 
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT CD_CIERRE FROM CIERRE WHERE FE_CIERRE='";
   gchar *ConsultaTmp = NULL;
   gchar *CodigoCierre = NULL;
   Gda_Field *field;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,Fecha,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();      
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
                                                  
        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);
   
        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
   
        CodigoCierre = (gchar *)gda_stringify_value(CodigoCierre, 0, field);
   
        return CodigoCierre;        
}


gint ConsultarVerificarExisteCierreMenorFecha(gchar *Fecha)
{                                                 
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT * FROM CIERRE WHERE FE_CIERRE<'";
   gchar *ConsultaTmp = NULL;
   gchar *FechaCierre = NULL;
   gint i=0;
   Gda_Field *field;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,Fecha,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();      
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
                                                  
        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 1);
   
        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
   
        FechaCierre = (gchar *)gda_stringify_value(FechaCierre, 6, field);

        while (!gda_recordset_eof(grs)) {
		i++;	
		gda_recordset_move_next(grs);
	}   

        return i;        
}

gchar* ConsultarFechaCierreUltimo(gchar *Fecha)
{                                                 
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT FE_CIERRE FROM CIERRE WHERE FE_CIERRE<'";
   gchar *ConsultaTmp = NULL;
   gchar *FechaCierre = NULL;
   Gda_Field *field;
        
        ConsultaTmp = g_strconcat(ConsultaInicial,Fecha,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);
 
        grs = gda_recordset_new();      
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);
   
	rc = grs->field_attributes->_length;                                 

        field = gda_field_new();
        field = gda_recordset_field_name (GDA_RECORDSET(grs), "FE_CIERRE");
   
        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");
   
        FechaCierre = (gchar *)gda_stringify_value(FechaCierre, 1, field);

        return FechaCierre;        
}

gfloat ConsultarDebeCierreTotal(gint CodigoCierre) 
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT SUM(VALOR) FROM TRANS_CIERRE WHERE TP_TRANSACCION='DEBE' AND CD_CIERRE=";
   gchar *ConsultaTmp = NULL;
   gfloat TotalDebeCierreTotal = 0;
   gchar *CadenaDebe = NULL;
   gchar *CadenaCodigoCierre = NULL;
   Gda_Field *field;

        rc = sscanf(CadenaCodigoCierre,"%d",&CodigoCierre);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoCierre,NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);

        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);

        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");

        CadenaDebe = (gchar *)gda_stringify_value(CadenaDebe, 0, field);

        rc = sscanf(CadenaDebe,"%f",&TotalDebeCierreTotal);

        return TotalDebeCierreTotal;

}

gfloat ConsultarHaberCierreTotal(gint CodigoCierre) 
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT SUM(VALOR) FROM TRANS_CIERRE WHERE TP_TRANSACCION='HABER' AND CD_CIERRE=";
   gchar *ConsultaTmp = NULL;
   gfloat TotalHaberCierreTotal = 0;
   gchar *CadenaHaber = NULL;
   gchar *CadenaCodigoCierre = NULL;
   Gda_Field *field;


        rc = sscanf(CadenaCodigoCierre,"%d",&CodigoCierre);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoCierre,NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);

        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);

        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");

        CadenaHaber = (gchar *)gda_stringify_value(CadenaHaber, 0, field);

        rc = sscanf(CadenaHaber,"%f",&TotalHaberCierreTotal);

        return TotalHaberCierreTotal;

}

gfloat ConsultarDebeCierreCtaContable(gint CodigoCierre, gchar *CtaContable) 
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT SUM(VALOR) FROM TRANS_CIERRE WHERE TP_TRANSACCION='DEBE' AND CD_CIERRE=";
   gchar *ConsultaTmp = NULL;
   gfloat TotalDebeCierre = 0;
   gchar *CadenaDebe = NULL;
   gchar *CadenaCodigoCierre = NULL;
   Gda_Field *field;


        rc = sscanf(CadenaCodigoCierre,"%d",&CodigoCierre);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoCierre,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp," AND CD_CTA_CONTABLE LIKE '",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);

        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);

        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");

        CadenaDebe = (gchar *)gda_stringify_value(CadenaDebe, 0, field);

        rc = sscanf(CadenaDebe,"%f",&TotalDebeCierre);

        return TotalDebeCierre;

}

gfloat ConsultarHaberCierreCtaContable(gint CodigoCierre, gchar *CtaContable) 
{
   Gda_Recordset *grs;
   gint rc;
   gchar *ConsultaInicial = "SELECT SUM(VALOR) FROM TRANS_CIERRE WHERE TP_TRANSACCION='HABER' AND CD_CIERRE=";
   gchar *ConsultaTmp = NULL;
   gfloat TotalHaberCierre = 0;
   gchar *CadenaHaber = NULL;
   gchar *CadenaCodigoCierre = NULL;
   Gda_Field *field;


        rc = sscanf(CadenaCodigoCierre,"%d",&CodigoCierre);

        ConsultaTmp = g_strconcat(ConsultaInicial,CadenaCodigoCierre,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp," AND CD_CTA_CONTABLE LIKE '",NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,CtaContable,NULL);
        ConsultaTmp = g_strconcat(ConsultaTmp,"'",NULL);

        grs = gda_recordset_new();
        gda_recordset_set_connection(GDA_RECORDSET(grs), cnc);
        rc = gda_recordset_open_txt(GDA_RECORDSET(grs),
                                        ConsultaTmp,
                                        GDA_OPEN_DYNAMIC,
                                        GDA_LOCK_PESSIMISTIC,
                                        0);

        gda_recordset_move_next (grs);

        field = gda_recordset_field_idx (GDA_RECORDSET(grs), 0);

        if (gda_field_isnull(field))
                g_print("\nEl Campo es nulo");

        CadenaHaber = (gchar *)gda_stringify_value(CadenaHaber, 0, field);

        rc = sscanf(CadenaHaber,"%f",&TotalHaberCierre);

        return TotalHaberCierre;

}

